#pragma warning(disable : 4996)
#include <windows.h>
#include <winbase.h>
#include <wininet.h>
#include <stdio.h>
#include <shlobj.h>

#define logging

#ifdef logging
static char logFile[MAX_PATH];
static WORD logFileParsed = -1;

//char protocol = "kartina";

void GetLogFile(char *pLog)
{
  SYSTEMTIME systemTime;
  GetLocalTime(&systemTime);
  if(logFileParsed != systemTime.wDay)
  {
    TCHAR folder[MAX_PATH];
    ::SHGetSpecialFolderPath(NULL,folder,CSIDL_COMMON_APPDATA,FALSE);
    sprintf(logFile,"%s\\Team MediaPortal\\MediaPortal TV Server\\log\\Kartina-%04.4d-%02.2d-%02.2d.Log",folder, systemTime.wYear, systemTime.wMonth, systemTime.wDay);
    logFileParsed=systemTime.wDay; // rec
  }
  strcpy(pLog, &logFile[0]);
}

void LogDebug(const char *fmt, ...)
{
  va_list ap;
  va_start(ap,fmt);

  char buffer[1000];
  int tmp;
  va_start(ap,fmt);
  tmp=vsprintf(buffer, fmt, ap);
  va_end(ap);
  SYSTEMTIME systemTime;
  GetLocalTime(&systemTime);

  TCHAR filename[1024];
  GetLogFile(filename);
  FILE* fp = fopen(filename,"a+");

  if (fp!=NULL)
  {
    fprintf(fp,"%02.2d-%02.2d-%04.4d %02.2d:%02.2d:%02.2d.%03.3d [%x]%s\n",
      systemTime.wDay, systemTime.wMonth, systemTime.wYear,
      systemTime.wHour,systemTime.wMinute,systemTime.wSecond,
      systemTime.wMilliseconds,
      GetCurrentThreadId(),
      buffer);
    fclose(fp);
  }
  char buf[1000];
  sprintf(buf,"%02.2d-%02.2d-%04.4d %02.2d:%02.2d:%02.2d %s\n",
    systemTime.wDay, systemTime.wMonth, systemTime.wYear,
    systemTime.wHour,systemTime.wMinute,systemTime.wSecond,
    buffer);
  ::OutputDebugString(buf);
};

#endif

void  GetProtocol(int* transport, char** protocol)
{
  *transport = 3; //tHTTP
  *protocol = "kartina";
}

bool GetRealURL(URL_COMPONENTS url, char* buffer)
{
  LogDebug("KARTINA! %s",url.lpszHostName);

	HINTERNET hINet=NULL; 
	HINTERNET hConnection=NULL;
	HINTERNET hData=NULL;
	char get_string[1024], ip[126];

	hINet = InternetOpen("Mozilla/4.0", INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0 );
	if ( hINet ) 
		memset(ip, 0, (url.dwHostNameLength + 1) * sizeof(TCHAR));
		strncat(ip, url.lpszHostName, url.dwHostNameLength);

		hConnection = InternetConnect( hINet, ip, 80, " ", " ", INTERNET_SERVICE_HTTP, 0, 0 );

	if ( hConnection ) {
		memset(get_string, 0, (url.dwUrlPathLength + url.dwExtraInfoLength + 1) * sizeof(TCHAR));
		strncat(get_string, url.lpszUrlPath, url.dwUrlPathLength );
		strncat(get_string, url.lpszExtraInfo, url.dwExtraInfoLength );

		hData = HttpOpenRequest( hConnection, "GET", get_string, 
			NULL, NULL, NULL, INTERNET_FLAG_KEEP_CONNECTION, 0 );
	} else {
		InternetCloseHandle(hINet);
	}

	if ( hData ) {
		LogDebug("Kartina before Send request: %s %d %s",ip,80,get_string);
		if (!HttpSendRequest( hData, NULL, -1, NULL, 0)) {
			LogDebug("Error in HttpSendRequest %f",(DWORD)GetLastError);
			return false;
		}
	} else {
		InternetCloseHandle(hINet);
		InternetCloseHandle(hConnection);
		return false;
	}

	DWORD len;
	LogDebug("Kartina: URL before %s",buffer);
	int resp = InternetReadFile( hData, buffer, 2048, &len ) ;
	if (!resp) {
		LogDebug("False responce %d",GetLastError());
	}
	LogDebug("Kartina: returned URL %s",buffer);
	InternetCloseHandle(hData);
	InternetCloseHandle(hConnection);
	InternetCloseHandle(hINet);
//	WSACleanup();
	return true;
}
